/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//Config
const config = require('../../config.json');

//NPM Imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const emailChangeModel = require('../schemas/user/emailChangeSchema');
const csrfUtils = require('../utils/csrfUtils');

//gateway for resetting password
module.exports.get = async function(req, res){
    try{
        //Check for validation errors
        const validResult = validationResult(req);

        //If there are none
        if(validResult.isEmpty()){
            //Get sanatized/validated data
            const {token} = matchedData(req);

            //Consume the password reset token using given input
            const requestDB = await emailChangeModel.findOne({token});

            //If we have an invalid request
            if(requestDB == null){
                return res.render('emailChange', {instance: config.instanceName, user: req.session.user, csrfToken: csrfUtils.generateToken(req), valid: false});
            }

            //Speak of our success (don't wait for the emails to be sent)
            res.render('emailChange', {instance: config.instanceName, user: req.session.user, csrfToken: csrfUtils.generateToken(req), valid: true});

            //Consume the request
            await requestDB.consume();
        }else{
            return res.render('emailChange', {instance: config.instanceName, user: req.session.user, csrfToken: csrfUtils.generateToken(req), valid: false});
        }
    }catch(err){
        return res.render('emailChange', {instance: config.instanceName, user: req.session.user, csrfToken: csrfUtils.generateToken(req), valid: false});
    }
}